﻿Imports System
Imports System.Text
Imports System.Threading
Imports xidcusb

Namespace testvbnet
    Class testapp
        Private Shared Sub print_state(ByVal state As State)
            Console.WriteLine("state: {0} pwm: {1} rpm: {2} pos: {3} temp: {4} flags: {5}", state.device_state, state.pwm_state, state.current_rpm, state.current_position, state.current_temp, _
             state.flags)
        End Sub

        Public Shared Sub Main(ByVal args As String())
            Dim device As Integer = -1
            Dim res As Result
            Try
                Dim devices As String()
                res = API.enumerate_devices(devices, 1)
                If res <> Result.ok Then
                    Throw New Exception("Error " & res.ToString())
                End If

                If devices.Length = 0 Then
                    Throw New Exception("No devices")
                End If

                For Each dev In devices
                    System.Console.WriteLine("Found device {0}", dev)
                Next

                'String deviceName = "\\\\.\\COM8";
                Dim deviceName As [String] = devices(0)
                System.Console.WriteLine("Using device {0}", deviceName)

                device = API.open_device(deviceName)
                Console.WriteLine("Device {0}", device)

                Dim state As State
                res = API.get_status(device, state)
                If res <> Result.ok Then
                    Throw New Exception("Error " & res.ToString())
                End If
                print_state(state)

                res = API.command_zero(device)
                If res <> Result.ok Then
                    Throw New Exception("Error " & res.ToString())
                End If

                res = API.get_status(device, state)
                If res <> Result.ok Then
                    Throw New Exception("Error " & res.ToString())
                End If
                print_state(state)

                Console.WriteLine("running...")
                res = API.command_right(device)
                If res <> Result.ok Then
                    Throw New Exception("Error " & res.ToString())
                End If

                Thread.Sleep(1 * 1000)

                res = API.get_status(device, state)
                If res <> Result.ok Then
                    Throw New Exception("Error " & res.ToString())
                End If
                print_state(state)

                Thread.Sleep(10 * 1000)

                Console.WriteLine("stopping...")
                res = API.command_stop(device)
                If res <> Result.ok Then
                    Throw New Exception("Error " & res.ToString())
                End If

                res = API.get_status(device, state)
                If res <> Result.ok Then
                    Throw New Exception("Error " & res.ToString())
                End If
                print_state(state)

                Console.WriteLine("Done...")
            Catch e As Exception
                Console.WriteLine("Exception " & e.Message)
            Finally
                If device <> -1 Then
                    API.close_device(device)
                End If
            End Try
            'Console.ReadKey();
        End Sub
    End Class
End Namespace

